'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = function (app, connect) {

    return {
        $model: $model,
        $connect: $connect
    };

    function $connect(getUIState, callbacks) {
        for (var _len = arguments.length, connectArgs = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
            connectArgs[_key - 2] = arguments[_key];
        }

        return function (UI) {
            var ComponentWithPrefix = function (_React$Component) {
                _inherits(ComponentWithPrefix, _React$Component);

                function ComponentWithPrefix(props) {
                    _classCallCheck(this, ComponentWithPrefix);

                    return _possibleConstructorReturn(this, (ComponentWithPrefix.__proto__ || Object.getPrototypeOf(ComponentWithPrefix)).call(this, props));
                }

                _createClass(ComponentWithPrefix, [{
                    key: 'render',
                    value: function render() {
                        var prefix = this.props.prefix;
                        var cachePath = [getUIState, UI, callbacks, JSON.stringify(prefix)];
                        var Component = (0, _cache.getCache)(cachePath);

                        if (Component) {
                            return _react2.default.createElement(Component, this.props);
                        }

                        var mapDispatchToProps = (0, _wrapCallbacks2.default)(app, callbacks, prefix);

                        var mapStateToProps = function mapStateToProps() {
                            for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                                args[_key2] = arguments[_key2];
                            }

                            var state = args[0],
                                extArgs = args.slice(1);

                            return getUIState.apply(undefined, [(0, _proxy.proxyStateForUI)(state, prefix)].concat(_toConsumableArray(extArgs)));
                        };
                        Component = connect.apply(undefined, [mapStateToProps, mapDispatchToProps].concat(connectArgs))(UI);
                        (0, _cache.setCache)(cachePath, Component);

                        return _react2.default.createElement(Component, this.props);
                    }
                }]);

                return ComponentWithPrefix;
            }(_react2.default.Component);

            return ComponentWithPrefix;
        };
    }

    function $model(m) {
        (0, _invariant2.default)(m.prefix, 'dva->$model: prefix should be defined');
        var modelState = _extends({}, m.state);

        m.state = m.prefix.reduce(function (ret, key) {
            ret[key] = modelState;
            return ret;
        }, {});

        // reducers
        m.reducers = (0, _proxy.proxyReducer)(m.reducers);

        app.model(m);
    }
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _cache = require('./cache');

var _proxy = require('./proxy');

var _wrapCallbacks = require('./wrapCallbacks');

var _wrapCallbacks2 = _interopRequireDefault(_wrapCallbacks);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }