'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function (app, callbacks, prefix) {
    var initializedCallbacks = {};

    return !callbacks ? undefined : function () {
        var prefixCacheKey = JSON.stringify(prefix);

        if (!initializedCallbacks[prefixCacheKey]) {
            initializedCallbacks[prefixCacheKey] = {};

            (0, _invariant2.default)(_lodash2.default.isPlainObject(callbacks), 'dva->$connect: callbacks should be plain object');

            Object.keys(callbacks).map(function (key) {

                (0, _invariant2.default)(typeof callbacks[key] === 'function', 'dva->$connect: callbacks\'s each item should be function, but found ' + key);

                initializedCallbacks[prefixCacheKey][key] = function () {
                    var _callbacks$key;

                    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                        args[_key] = arguments[_key];
                    }

                    (_callbacks$key = callbacks[key]).call.apply(_callbacks$key, [null, {
                        getState: (0, _proxy.proxyGetState)(app._store.getState, prefix),
                        dispatch: (0, _proxy.proxyDispatch)(app._store.dispatch, key, prefix)
                    }].concat(args));
                };
            });
        }
        return initializedCallbacks[prefixCacheKey];
    };
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _proxy = require('./proxy');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }